// DrawPane.as
// John Maloney, August 2009
//
// DrawPane is a very minimal drawing environment -- just enough to
// allow a bit of interactive graphics to demonstrate the BlocksEngine.

package {
	import flash.display.Shape;
	import flash.display.Sprite;

public class DrawPane extends Sprite {
	public var paneW:int = 200, paneH:int = 200;
	public var fillColor:int = 0xFF0000;
	public var hue:int = 0;

	public var mouseIsDown:Boolean = false;

	public function DrawPane(w:int, h:int) {
		paneW = w;
		paneH = h;

		var m:Shape = new Shape();
		m.graphics.beginFill(0);
		m.graphics.drawRect(0, 0, paneW, paneH);
		m.graphics.endFill();
		addChild(m);
		mask = m;

		clear();
	}

	public function clear():void {
		graphics.clear();
		graphics.beginFill(0xFFFFFF);
		graphics.drawRect(0, 0, paneW, paneH);
		graphics.endFill();
	}

	public function setRGB(r:int, g:int, b:int):void {
		r = Math.min(Math.max(int(r), 0), 255);
		g = Math.min(Math.max(int(g), 0), 255);
		b = Math.min(Math.max(int(b), 0), 255);
		fillColor = (r << 16) | (g << 8) | b;
	}

	public function setHue(h:int):void {
		var hsv:Array = Color.rgb2hsv(fillColor);
		hue = h % 360;
		fillColor = Color.fromHSV(hue, hsv[1], hsv[2]);
	}

	public function rectangle(x:int, y:int, w:int, h:int):void {
		graphics.beginFill(fillColor);
		graphics.drawRect(x, y, w, h);
		graphics.endFill();
	}

	public function ellipse(x:int, y:int, w:int, h:int):void {
		graphics.beginFill(fillColor);
		graphics.drawEllipse(x, y, w, h);
		graphics.endFill();
	}

}}
